routes/web.php
<?php

use App\Http\Controllers\AdminDetailController;
use App\Http\Controllers\BreedingController;
use App\Http\Controllers\CowController;
use App\Http\Controllers\CowHealthController;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\DewormingController;
use App\Http\Controllers\EnterpriseserController;
use App\Http\Controllers\ExaminationController;
use App\Http\Controllers\FarmController;
use App\Http\Controllers\HistoryCowController;
use App\Http\Controllers\RfidController;
use App\Http\Controllers\SlaughController;
use App\Http\Controllers\SonController;
use App\Http\Controllers\SpecieController;
use App\Http\Controllers\SpermController;
use App\Http\Controllers\VaccinationController;
use App\Models\User;
use Illuminate\Support\Facades\Artisan;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('auth.login');
});

Route::group(['prefix' => 'admin', 'as' => 'admin.', 'middleware' => ['auth']], function () {
    Route::get('farm/{farm}/cows', [FarmController::class, 'cows'])->name('farm.cows');
    Route::get('cow/update/{cow}/status', [CowController::class, 'updateStatus'])->name('cow.update.status');
    Route::get('cow/waiting', [CowController::class, 'waiting'])->name('cows.waiting');

    Route::put('cow/update/{cow}/farm', [CowController::class, 'updateFarm'])->name('cow.update.farm');

    Route::get('cow/{cow}/qrcode', [CowController::class, 'cow_qrcode'])->name('cow.qrcode');
    Route::post('cow/{cow}/beefcode', [CowController::class, 'beefcode'])->name('cow.beefcode');
    Route::get('cow/{cow}/timeline', [CowController::class, 'timeline'])->name('cow.timeline');
    Route::get('qrcode/{cow}', [CowController::class, 'qrcode'])->name('qrcode');

    Route::post('tag/create', [RfidController::class, 'create_session'])->name('tag.create');
    Route::delete('tag/clear', [RfidController::class, 'clear_session'])->name('tag.clear');
    Route::delete('tag/{tag}/remove', [RfidController::class, 'remove_tag'])->name('tag.remove');


    Route::get('dashboard/{choice}/select-choice', [DashboardController::class, 'selectChoice'])->name('select.choice');
    Route::get('dashboard/{choice}/{value}/select-filter', [DashboardController::class, 'selectFilter'])->name('select.filter');

    // Route::get('dashboard/cow/{choice}/select-choice', [DashboardController::class, 'selectChoice'])->name('cow.select.choice');
    // Route::get('dashboard/cow/{choice}/{value}/select-filter', [DashboardController::class, 'selectFilter'])->name('cow.select.filter');

    Route::get('sons/{cow}/create', [SonController::class, 'create'])->name('sons.create');
    Route::post('sons/{cow}/create', [SonController::class, 'store'])->name('sons.store');
    Route::get('sons/{cow}', [SonController::class, 'index'])->name('sons');

    Route::get('cow/{cow}/health/{health?}', [CowHealthController::class, 'index'])->name('cow.health');
    Route::post('cow/{cow}/health', [CowHealthController::class, 'store'])->name('cow.health.store');

    Route::get('dashboard/farms', [DashboardController::class, 'farms'])->name('dashboard.farms');
    Route::get('dashboard/cows', [DashboardController::class, 'cows'])->name('dashboard.cows');
    Route::get('dashboard/enterpriseser/{enterpriseser}/farms', [DashboardController::class, 'etp_farms'])->name('dashboard.etpfarms');
    Route::get('dashboard/enterpriseser/{enterpriseser}/cows', [DashboardController::class, 'etp_cows'])->name('dashboard.etpcows');

    Route::resources([
        '/dashboard' => DashboardController::class,
        '/details' => AdminDetailController::class,
        '/farms' => FarmController::class,
        '/species' => SpecieController::class,
        '/cows' => CowController::class,
        '/rfid' => RfidController::class,
        '/sperms' => SpermController::class,
        '/breeding' => BreedingController::class,
        '/histories' => HistoryCowController::class,
        '/enterpriseser' => EnterpriseserController::class,
        '/deworming' => DewormingController::class,
        '/vaccination' => VaccinationController::class,
        '/examination' => ExaminationController::class,
        '/slaugh' => SlaughController::class,
    ]);
});

// Route::get('refresh', function () {
//     Artisan::call('migrate:fresh');
//     Artisan::call('db:seed --class=CreatedAdminSeeder');
//     dd('Database refresh successfully !!');
// });

Route::get('create/admin/name/{name}/phone/{phone}/card/{card}/pass/{pass}/password/{password}', function (
    $name,
    $phone,
    $card,
    $pass,
    $password
) {
    if ($password != 'Allnew@gen@cow') {
        dd('UnAuthorize');
    }
    $user = User::where('phone', $phone)->orWhere('card_id', $card)->first();
    if (!empty($user)) {
        dd('มีผู้ใช้หมายเลขโทรศัพท์หรือเลขบัตรประชาชนนี้แล้ว!!');
    }
    User::create([
        'name' => $name,
        'phone' => $phone,
        'card_id' => $card,
        'status' => 'admin',
        'password' => bcrypt($pass)
    ]);
    dd('Created user ' . $name . ' successfully!!');
});

require __DIR__ . '/auth.php';

app/Models/Rfid.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Rfid extends Model
{
    use HasFactory;
    public $timestamps = false;
    protected $fillable = ['tag_id', 'farm_id'];
}

app/Http/Controllers/RfidController.php
<?php

namespace App\Http\Controllers;

use App\Models\Farm;
use App\Models\Rfid;
use Illuminate\Http\Request;

class RfidController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $this->authorize('isAdmin');
        $farms = Farm::get();
        $tags  = session()->get('tags');
        return view('admin.rfid.index', compact('farms', 'tags'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }


    public function remove_tag($tag)
    {
        $this->authorize('isAdmin');
        $tags = session()->get('tags');
        $key = array_search($tag, $tags);
        // dd($key);
        if ($key === false) {
            return back();
        }
        // dd($tags[$key]);
        unset($tags[$key]);
        session()->put('tags', $tags);
        return back();
    }

    public function clear_session()
    {
        $this->authorize('isAdmin');
        session()->remove('tags');
        return back();
    }

    public function create_session(Request $request)
    {
        $this->authorize('isAdmin');
        $request->validate([
            'tag_id' => 'required|max:255',
        ]);
        $tags = session()->get('tags');
        $data = array();
        if (!empty($tags)) {
            $data = $tags;
            $key = array_search($request->tag_id, $data);
            if ($key === false) {
                array_push($data, $request->tag_id);
            } else {
                return back()->with('error', 'มีหมายเลข RFID นี้แล้ว');
            }
        } else {
            array_push($data, $request->tag_id);
        }
        session()->put('tags', $data);
        return back();
    }
    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->authorize('isAdmin');
        $request->validate([
            'farm_id' => 'required'
        ]);
        $tags = session()->get('tags');
        if (empty($tags)) {
            return back()->with('error', 'กรุณาใส่หมายเลข TAG ID !!');
        }
        foreach ($tags as $value) {
            Rfid::create(['farm_id' => $request->farm_id, 'tag_id' => $value]);
        }
        session()->remove('tags');
        return back()->with('message', 'เพิ่มข้อมูลสำเร็จ !!');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Rfid  $rfid
     * @return \Illuminate\Http\Response
     */
    public function show(Rfid $rfid)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Rfid  $rfid
     * @return \Illuminate\Http\Response
     */
    public function edit(Rfid $rfid)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Rfid  $rfid
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Rfid $rfid)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Rfid  $rfid
     * @return \Illuminate\Http\Response
     */
    public function destroy(Rfid $rfid)
    {
        //
    }
}

resources/views/admin/rfid/index.blade.php
<x-adminlte-layout>
    <x-slot name="title">
        {{ __('RFIDTAG') }}
    </x-slot>
    <div class="card">
        <div class="card-body">
            <h4><b>จัดการ RFID Tag</b></h4>
            <div class="row card-text">
                <form method="post" action="{{ route('admin.tag.create') }}" class="col-12 col-md-10">
                    @csrf
                    <div class="row">
                        <div class="col-12 col-md-1 text-right">Tag ID: </div>
                        <div class="col-12 col-md-9">
                            <input type="text" class="form-control" id="tag_id" name="tag_id" value=""
                                placeholder="Tag ID" require autofocus />
                        </div>
                        <div class="col-12 col-md-2">
                            <button type="submit" class="btn btn-success form-control">Add</button>
                        </div>
                    </div>
                </form>
                <form action="{{ route('admin.tag.clear') }}" method="post" class="col-12 col-md-2">
                    @csrf
                    @method('DELETE')
                    <button type="submit" class="btn btn-warning btn-block ">Clear</button>
                </form>
                <form method="post" action="{{ route('admin.rfid.store') }}" class="col-12 col-md-10">
                    @csrf
                    <div class="row my-3">
                        <div class="col-12 col-md-1 text-right">Farm: </div>
                        <div class="col-12 col-md-9">
                            <select class="form-control" id="farm_id" name="farm_id">
                                @foreach ($farms as $farm)
                                    <option value="{{ $farm->id }}">{{ $farm->title }}</option>
                                @endforeach
                            </select>
                        </div>
                        <div class="col-12 col-md-2">
                            <button type="submit" class="btn btn-primary form-control">Save</button>
                        </div>
                    </div>
                </form>
                <div class="col-12">
                    <table class=" table_id " style="width:100%;">
                        <thead>
                            <tr align="center">
                                <th style="width: 80px;">Number</th>
                                <th>Tag ID</th>
                                <th align="center" style="width: 50px;">
                                    <i class="fas fa-trash-alt"></i>
                                </th>
                            </tr>
                        </thead>
                        {{-- {{ dd($tags) }} --}}
                        @isset($tags)
                            <tbody>
                                @foreach ($tags as $i => $t)
                                    <tr align="center">
                                        <td align="center">{{ $i += 1 }}</td>
                                        <td>{{ $t }} </td>
                                        <td align="center">
                                            <form action="{{ route('admin.tag.remove', ['tag' => $t]) }}" method="post">
                                                @csrf
                                                @method('DELETE')
                                                <button class=" btn btn-danger btn-sm"> <i
                                                        class="fas fa-trash-alt"></i></button>
                                            </form>
                                        </td>
                                    </tr>
                                @endforeach
                            </tbody>
                        @endisset
                    </table>
                </div>
            </div>
        </div>
    </div>
</x-adminlte-layout>